var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from "react";
import { runIfFn } from "./utils/function";
import { overridePredefinedKeys, resolveObjValues } from "./utils/object";
export function createRenderer(options) {
    return function (overrides) {
        if (overrides === void 0) { overrides = {}; }
        var Component = options.component, _a = options.data, data = _a === void 0 ? {} : _a, _b = options.props, props = _b === void 0 ? {} : _b, renderFunction = options.renderFunction;
        var initialData = runIfFn(data);
        var dataWithOverrides = overridePredefinedKeys(initialData, overrides);
        var initialProps = runIfFn(props, dataWithOverrides);
        var propsWithOverrides = overridePredefinedKeys(initialProps, overrides);
        propsWithOverrides = resolveObjValues(propsWithOverrides);
        var renderUtils = renderFunction(React.createElement(Component, __assign({}, propsWithOverrides)), { wrapper: options.wrapper });
        return __assign(__assign(__assign({}, propsWithOverrides), dataWithOverrides), { renderUtils: renderUtils });
    };
}
//# sourceMappingURL=create-renderer.js.map